#ifndef SelectAttrDialog_H
#define SelectAttrDialog_H

#include <flydevices_export.h>

#include <QDialog>

namespace Ui
{
class SelectAttrDialog;
}

class FLY_DEVICES_EXPORT SelectAttrDialog : public QDialog
{

    Q_OBJECT

public:

    SelectAttrDialog(QWidget *parent = 0);
    virtual ~SelectAttrDialog();

    bool isCheckable();
    void setCheckable( bool /*checkable*/ );

    const QSet< QString > &defaultCheckedProperties() const;
    void setDefaultCheckedProperties(const QSet<QString> & /*defaultCheckedProperties*/ );

    QList< QPair< QString, QVariant > > checkedPropertiesVariant() const;
    QList< QPair< QString, QString > > checkedPropertiesString() const;

public slots:

    virtual void accept();

protected slots:

    void filterDevices( const QString & );
    void updateDeviceInfo();
    void configureCommands();
    void refreshDevice();

private:

    Ui::SelectAttrDialog *_ui;

};

#endif // SelectAttrDialog_H
