#ifndef SETTINGS_DIALOG_H
#define SETTINGS_DIALOG_H

#include <flydevices_export.h>

#include <QDialog>
#include <QMap>

class QFormLayout;
class QAbstractButton;
class QDialogButtonBox;
class QLineEdit;

class FLY_DEVICES_EXPORT SettingsDialog : public QDialog
{
    Q_OBJECT
public:
    SettingsDialog(QWidget* parent = 0);
    ~SettingsDialog();

    static void initParamNames();

    static QMap<QString, QString> defaults_;
    static QMap<QString, QString> cmdLabelTexts_;
    static QMap<QString, QString> argLabelTexts_;

public slots:
    void btnClicked(QAbstractButton* btn);

private:
    QFormLayout* formLt_;
    QDialogButtonBox* bBox_;
    QMap<QString, QLineEdit*> lineEdits_;
};

#endif
